package cn.ibizlab.eam.core.eam_core.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.eam.core.eam_core.domain.EMEQLCTTIRes;
import cn.ibizlab.eam.core.eam_core.filter.EMEQLCTTIResSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EMEQLCTTIRes] 服务对象接口
 */
public interface IEMEQLCTTIResService extends IService<EMEQLCTTIRes>{

    boolean create(EMEQLCTTIRes et) ;
    void createBatch(List<EMEQLCTTIRes> list) ;
    boolean update(EMEQLCTTIRes et) ;
    void updateBatch(List<EMEQLCTTIRes> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EMEQLCTTIRes get(String key) ;
    EMEQLCTTIRes getDraft(EMEQLCTTIRes et) ;
    boolean checkKey(EMEQLCTTIRes et) ;
    boolean save(EMEQLCTTIRes et) ;
    void saveBatch(List<EMEQLCTTIRes> list) ;
    Page<EMEQLCTTIRes> searchDefault(EMEQLCTTIResSearchContext context) ;
    List<EMEQLCTTIRes> selectByEquipid(String emequipid) ;
    void removeByEquipid(String emequipid) ;
    List<EMEQLCTTIRes> selectByLabserviceid(String emserviceid) ;
    void removeByLabserviceid(String emserviceid) ;
    List<EMEQLCTTIRes> selectByMserviceid(String emserviceid) ;
    void removeByMserviceid(String emserviceid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EMEQLCTTIRes> getEmeqlcttiresByIds(List<String> ids) ;
    List<EMEQLCTTIRes> getEmeqlcttiresByEntities(List<EMEQLCTTIRes> entities) ;
}


